;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo		tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez	abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina		imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "cpctelera_functions.h.s"
;.include "key_sistem.h.s"
.include "man/game_manager.h.s"
.include "sys/render_system.h.s"

;;
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;


.globl cpct_disableFirmware_asm
.area _DATA
.area _CODE
;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
    ld c, #0
    halt
    call cpct_setVideoMode_asm
   call cpct_disableFirmware_asm
   ld hl, #int_handler1
   call cpct_waitVSYNC_asm
   halt
   halt
   call cpct_waitVSYNC_asm
   call cpct_setInterruptHandler_asm
   ei
newgame:
   ;; Init systems
   call man_game_init
;; Loop forever
loop:
   call man_game_update
   call man_game_renderer
   jr loop



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
set_int_handler:
	ld hl, #0x38
	ld (hl), #0xc3
	inc hl
	ld (hl), #<int_handler1
	inc hl
	ld (hl), #>int_handler1
	inc hl
	ld (hl), #0xc9
	ret


uncontador: .db #05
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
int_handler1::

; 	ld a, (uncontador)
; 	xor #1
; 	ld (uncontador), a

; 	ld h, #0
; 	ld l, #16
; 	call cpct_setPALColour_asm

; 	ld h, #6
; 	ld l, #16
; 	call cpct_setPALColour_asm
	
	ld a, (song_playing)
	or a
	call nz, cpct_akp_musicPlay_asm

	ld a, #01
	ld (render_interrupt), a

	ld hl, #int_handler2
   	call cpct_setInterruptHandler_asm	
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
int_handler2::
; 	ld a, (uncontador)
; 	xor #1
; 	ld (uncontador), a

; 	ld h, #1
; 	ld l, #16
; 	call cpct_setPALColour_asm
	call cpct_scanKeyboard_if_asm

	ld a, #00
	ld (render_interrupt), a

	ld hl, #int_handler3
   	call cpct_setInterruptHandler_asm
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
int_handler3::
; 	ld a, (uncontador)
; 	xor #2
; 	ld (uncontador), a

; 	ld h, #2
; 	ld l, #16
; 	call cpct_setPALColour_asm
	

	ld hl, #int_handler4
   	call cpct_setInterruptHandler_asm
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
int_handler4::
; 	ld a, (uncontador)
; 	xor #1
; 	ld (uncontador), a

; 	ld h, #3
; 	ld l, #16
; 	call cpct_setPALColour_asm

; 	ld a, (starscreen_bool)
; 	ld b, a
; 	ld a, (gameoverscreen_bool)
; 	or b
; 	call z, rendersys_drawintfc
	

	ld hl, #int_handler5
   	call cpct_setInterruptHandler_asm
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
int_handler5::
; 	ld a, (uncontador)
; 	xor #1
; 	ld (uncontador), a

; 	ld h, #4
; 	ld l, #16
; 	call cpct_setPALColour_asm
	ld hl, #int_handler6
   	call cpct_setInterruptHandler_asm
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Called every interruption
;;
;;DESTROYS: AF, BC, DE
;;
int_handler6::
; 	ld a, (uncontador)
; 	xor #1
; 	ld (uncontador), a

; 	ld h, #5
; 	ld l, #16
; 	call cpct_setPALColour_asm
	ld hl, #int_handler1
   	call cpct_setInterruptHandler_asm
	ret

