;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo		tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez	abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina		imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "assets/sprites.h.s"
.include "man/entity_manager.h.s"
.include "man/animation_manager.h.s"
.include "cpctelera.h.s"


animation_player_right::
	.dw _sp_enemyNormal_12, animation_player_right + 4
	.dw _sp_enemyNormal_13, animation_player_right + 8 
	.dw _sp_enemyNormal_12, animation_player_right + 12
	.dw _sp_enemyNormal_14, animation_player_right

animation_player_up::
	.dw _sp_enemyNormal_15, animation_player_up + 4 
	.dw _sp_enemyNormal_16, animation_player_up + 8
	.dw _sp_enemyNormal_15, animation_player_up + 12 
	.dw _sp_enemyNormal_17, animation_player_up

animation_player_left::
	.dw _sp_enemyNormal_18, animation_player_left + 4 
	.dw _sp_enemyNormal_19, animation_player_left + 8
	.dw _sp_enemyNormal_18, animation_player_left + 12 
	.dw _sp_enemyNormal_20, animation_player_left

animation_player_down::
	.dw _sp_enemyNormal_21, animation_player_down + 4 
	.dw _sp_enemyNormal_22, animation_player_down + 8
	.dw _sp_enemyNormal_21, animation_player_down + 12 
	.dw _sp_enemyNormal_23, animation_player_down

animation_player_standing::
	.dw _sp_enemyNormal_15, animation_player_standing

player_animation_array::
	.dw animation_player_left, animation_player_right, animation_player_up, animation_player_down, animation_player_standing


animation_enemy_up::
	.dw _sp_enemyNormal_00, animation_enemy_up + 4 
	.dw _sp_enemyNormal_01, animation_enemy_up + 8
	.dw _sp_enemyNormal_00, animation_enemy_up + 12 
	.dw _sp_enemyNormal_02, animation_enemy_up

animation_enemy_down::
	.dw _sp_enemyNormal_03, animation_enemy_down + 4 
	.dw _sp_enemyNormal_04, animation_enemy_down + 8
	.dw _sp_enemyNormal_03, animation_enemy_down + 12 
	.dw _sp_enemyNormal_05, animation_enemy_down

animation_enemy_left::
	.dw _sp_enemyNormal_06, animation_enemy_left + 4 
	.dw _sp_enemyNormal_07, animation_enemy_left + 8
	.dw _sp_enemyNormal_06, animation_enemy_left + 12 
	.dw _sp_enemyNormal_08, animation_enemy_left

animation_enemy_right::
	.dw _sp_enemyNormal_09, animation_enemy_right + 4 
	.dw _sp_enemyNormal_10, animation_enemy_right + 8
	.dw _sp_enemyNormal_09, animation_enemy_right + 12 
	.dw _sp_enemyNormal_11, animation_enemy_right

animation_enemy_standing::
	.dw _sp_enemyNormal_03, animation_enemy_standing

enemy_animation_array::
	.dw animation_enemy_left, animation_enemy_right, animation_enemy_up, animation_enemy_down, animation_enemy_standing



animation_red_down::
	.dw _sp_enemyDoble_00, animation_red_down + 4 
	.dw _sp_enemyDoble_01, animation_red_down + 8
	.dw _sp_enemyDoble_00, animation_red_down + 12 
	.dw _sp_enemyDoble_02, animation_red_down

animation_red_up::
	.dw _sp_enemyDoble_03, animation_red_up + 4 
	.dw _sp_enemyDoble_04, animation_red_up + 8
	.dw _sp_enemyDoble_03, animation_red_up + 12 
	.dw _sp_enemyDoble_05, animation_red_up

animation_red_left::
	.dw _sp_enemyDoble_06, animation_red_left + 4 
	.dw _sp_enemyDoble_07, animation_red_left + 8
	.dw _sp_enemyDoble_06, animation_red_left + 12 
	.dw _sp_enemyDoble_08, animation_red_left

animation_red_right::
	.dw _sp_enemyDoble_09, animation_red_right + 4 
	.dw _sp_enemyDoble_10, animation_red_right + 8
	.dw _sp_enemyDoble_09, animation_red_right + 12 
	.dw _sp_enemyDoble_11, animation_red_right

animation_red_standing::
	.dw _sp_enemyDoble_00, animation_red_standing

red_animation_array::
	.dw animation_red_left, animation_red_right, animation_red_up, animation_red_down, animation_red_standing



; animation_boss_down::
; 	.dw _sp_enemyJefe_00, animation_boss_down + 4 
; 	.dw _sp_enemyJefe_01, animation_boss_down + 8
; 	.dw _sp_enemyJefe_00, animation_boss_down + 12 
; 	.dw _sp_enemyJefe_02, animation_boss_down

; animation_boss_up::
; 	.dw _sp_enemyJefe_03, animation_boss_up + 4 
; 	.dw _sp_enemyJefe_04, animation_boss_up + 8
; 	.dw _sp_enemyJefe_03, animation_boss_up + 12 
; 	.dw _sp_enemyJefe_05, animation_boss_up

; animation_boss_left::
; 	.dw _sp_enemyJefe_06, animation_boss_left + 4 
; 	.dw _sp_enemyJefe_07, animation_boss_left + 8
; 	.dw _sp_enemyJefe_06, animation_boss_left + 12 
; 	.dw _sp_enemyJefe_08, animation_boss_left

; animation_boss_right::
; 	.dw _sp_enemyJefe_09, animation_boss_right + 4 
; 	.dw _sp_enemyJefe_10, animation_boss_right + 8
; 	.dw _sp_enemyJefe_09, animation_boss_right + 12 
; 	.dw _sp_enemyJefe_11, animation_boss_right

; animation_boss_standing::
; 	.dw _sp_enemyJefe_00, animation_boss_standing

; boss_animation_array::
; 	.dw animation_boss_left, animation_boss_right, animation_boss_up, animation_boss_down, animation_boss_standing




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Updates the animations of the entities
;;
;;INPUT:
;; IX: Entity array
;; A: Number of entities
;; 
;;DESTROYS: HL, DE, IX, AF
;;
man_animation_update::
	ld bc, #sizeof_e
_mau_loop:
	push af
	ld a, e_next_anim_h(ix)			;; Check if doesn't have animation
	or a
	jp z, _ignore
	call man_animation_animate_entity
_ignore:
	pop af
	add ix, bc
	dec a
	jp nz, _mau_loop
	ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Animates the entity pointed by IX
;;
;;INPUT:
;; IX: Entity array
;; 
;;DESTROYS: HL, DE, IX, AF
;;
man_animation_animate_entity::
	ld a, e_anim_count(ix)
	cp #0
	jp nz, _dont_animate
	ld h, e_next_anim_h(ix)			;; Load pointer to the next step of the animation
	ld l, e_next_anim_l(ix)

	ld e, (hl)					;; Load next sprite on hl
	inc hl
	ld d, (hl)
	inc hl

	ld e_pspr_l(ix), e			;; Put the sprite on the current sprite pointer on the entity
	ld e_pspr_h(ix), d

	ld e, (hl)					;; Load next step pointer onto de
	inc hl
	ld d, (hl)
	
	ld e_next_anim_l(ix), e
	ld e_next_anim_h(ix), d

	ld a, #anim_wait_cicles

_dont_animate:
	dec a
	ld e_anim_count(ix), a
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Animates the entity pointed by IX
;;
;;INPUT:
;; IX: Entity pointer
;; 
;;DESTROYS: AF, HL, DE, IY
;;
man_animation_change::
	ld a, e_vx(ix)
	or a
	jp z, _mac_check_y			;; If x is 0, the animation will be on y

	bit 7, a
	jp z, _mac_right				;; If bit 7 is 0, number is positive

_mac_left:
	;;Is moving left
	ld e, e_anim_array_l(ix)		;; Load animation array on hl
	ld d, e_anim_array_h(ix)
	ld__iyh_d
	ld__iyl_e

	ld e, ar_left_l(iy)			;; Set the left animation
	ld d, ar_left_h(iy)

	ld e_next_anim_l(ix), e
	ld e_next_anim_h(ix), d
	jp _mac_end
	

_mac_right:
	;;Is moving right
	ld e, e_anim_array_l(ix)		;; Load animation array on hl
	ld d, e_anim_array_h(ix)
	ld__iyh_d
	ld__iyl_e

	ld e, ar_right_l(iy)			;; Set the left animation
	ld d, ar_right_h(iy)

	ld e_next_anim_l(ix), e
	ld e_next_anim_h(ix), d
	jp _mac_end

_mac_check_y:
	ld a, e_vy(ix)
	or a
	jp z, _mac_standing			;; IF y is 0, the entity is not moving

	bit 7, a
	jp z, _mac_down

_mac_up:
	;;Is moving up
	ld e, e_anim_array_l(ix)		;; Load animation array on hl
	ld d, e_anim_array_h(ix)
	ld__iyh_d
	ld__iyl_e

	ld e, ar_up_l(iy)			;; Set the left animation
	ld d, ar_up_h(iy)

	ld e_next_anim_l(ix), e
	ld e_next_anim_h(ix), d
	jp _mac_end

_mac_down:
	;;Is moving down
	ld e, e_anim_array_l(ix)		;; Load animation array on hl
	ld d, e_anim_array_h(ix)
	ld__iyh_d
	ld__iyl_e

	ld e, ar_down_l(iy)			;; Set the left animation
	ld d, ar_down_h(iy)

	ld e_next_anim_l(ix), e
	ld e_next_anim_h(ix), d
	jp _mac_end

_mac_standing:
	;;Is not moving
	ld e, e_anim_array_l(ix)		;; Load animation array on hl
	ld d, e_anim_array_h(ix)
	ld__iyh_d
	ld__iyl_e

	ld e, ar_standing_l(iy)			;; Set the left animation
	ld d, ar_standing_h(iy)

	ld e_next_anim_l(ix), e
	ld e_next_anim_h(ix), d

_mac_end:
	xor a
	ld e_anim_count(ix), a
	ret