;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo   tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina    imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;
;; ENTITY MANAGER
;;
.globl entityman_getEntityArray
.globl entityman_getCollisionArray
.globl entityman_getDeleteArray
.globl entityman_create
.globl entityman_init
.globl entityman_delete
.globl entityman_deletearr_add
.globl entityman_reset_deletearr
.globl entityman_update

; _num_entities: .db 0
max_entities == 50

;;MACROS

;;Arrays
.macro DefineComponentArrayStructure _Tname, _N, _DefineTypeMacroDefault
    _Tname'_num:    .db 0 ;;Number of defined elements
    _Tname'_pend:   .dw _Tname'_array ;;Pointer to the end of the array
    _Tname'_array::
    .rept _N
        _DefineTypeMacroDefault;;Call _N times the initializer macro
    .endm
.endm

.macro DefaultEntity
    DefineEntityAnonymous 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x0000, e_ai_st_noAI, 0x0000, 0x0000, 0x0000, action_enemy_patrol ;;add el ultimo campo

.endm

.macro DefineComponentArrayStructure_Size _Tname, _N, _ComponentSize
    _Tname'_num:    .db 0 ;;Number of defined elements
    _Tname'_pend:   .dw _Tname'_array ;;Pointer to the end of the array
    _Tname'_array::
        .ds _N * _ComponentSize ;;Prodece as many 0's as total size
.endm


sizeof_c = 2
sizeof_d = 2

;;Entity array
.macro DefineEntityAnonymous _x, _y, _w, _h, _vx, _vy, _color, _collider, _checkcoll, _collision_handler, _aist, _pspr, _anim, _animation_array, _enemy_action
   .db   _x ;;Se puede cambiar este orden en caso de ser necesario
   .db   _y
   .db   _w
   .db   _h
   .db   _vx
   .db   _vy
   .db   _color
   .db   _collider
   .db   _checkcoll
   .dw   _collision_handler
   .db   0xDE, 0xAD   ;; AI-aim (ai_aim_x, ai_aim_y)
   .db   _aist        ;; AI-status (ai_st) if 0 -> no_ia
   .db   _aist        ;; AI-status (ai_pre_st) 
   .dw   0x0000       ;;Next AI Patrol Step
   .dw   _pspr
   .dw   0xCCCC
   .dw   _anim
   .db   00
   .db   00           ;; Last speed x
   .db   00           ;; Last speed y
   .dw   _animation_array
   .db   _enemy_action
.endm

e_x = 0
e_y = 1
e_w = 2
e_h = 3
e_vx = 4
e_vy = 5
e_col = 6
e_collider = 7
e_checkcoll = 8
e_collision_handler_l = 9
e_collision_handler_h = 10
e_ai_aim_x = 11
e_ai_aim_y = 12
e_ai_st = 13
e_ai_pre_st = 14
e_ai_patrol_step_l = 15
e_ai_patrol_step_h = 16
e_pspr_l =17
e_pspr_h = 18
e_lastVP_l = 19
e_lastVP_h = 20
e_next_anim_l = 21
e_next_anim_h = 22
e_anim_count = 23
e_last_vx = 24
e_last_vy = 25
e_anim_array_l = 26
e_anim_array_h = 27
e_enemy_action = 28
sizeof_e = 29

;; Entity t AI status enum
e_ai_st_noAI      = 0
e_ai_st_stand_by  = 1
e_ai_st_move_to   = 2
e_ai_st_patrol    = 3
e_ai_st_charge    = 4
e_ai_st_shoot     = 5
e_ai_st_to_player = 6

;; Entity status
e_w_invalidEntity = 0x00  ;;Entity width=0 means invalid entity

.macro DefineEntity _name, _x, _y, _w, _h, _vx, _vy, _color, _collider, _checkcoll, _collision_handler, _aist, _pspr, _anim, _animation_array, _enemy_action
_name::
    DefineEntityAnonymous _x, _y, _w, _h, _vx, _vy, _color, _collider, _checkcoll, _collision_handler, _aist, _pspr, _anim, _animation_array, _enemy_action
.endm

;; Object type collition enum
coll_type_player = 1
coll_type_enemy = 2
coll_type_bullet = 3
coll_type_enemy_bullet = 4
coll_type_nocoll = 0

;; Type of enemy action
action_enemy_patrol = 0
action_enemy_shoot = 1
action_enemy_to_player = 2