;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo       tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina      imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "sys/input_system.h.s"
.include "sys/render_system.h.s"
.include "sys/ai_control.h.s"
.include "man/entity_manager.h.s"
.include "man/collision_manager.h.s"
.include "man/game_manager.h.s"
.include "sys/physics_system.h.s"
.include "cpctelera_functions.h.s"
.include "man/player_manager.h.s"
.include "man/scroll_manager.h.s"
.include "man/patrol_manager.h.s"
.include "assets/sprites.h.s"
.include "man/animation_manager.h.s"


;;DEFINE ENTITIES
;;                  X   Y   W  H  SX SY COLOR TYPE_OBJECT    .... IA_STATUS
; DefineEntity enemy, 60, 20, 4, 8, 0, 0, 0xF0, coll_type_enemy, 0, 0x0000, #e_ai_st_stand_by, _sp_mainchar
; DefineEntity enemy2, 20, 10, 4, 16, 1, 1, 0xF0, coll_type_enemy, 0, 0x0000, #e_ai_st_stand_by, _sp_mainchar
; DefineEntity block, 12, 70, 4, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_mainchar
;DefineEntity player, 40, 80, 4, 16, 0, 0, 0xFF, coll_type_player, 1, 0x0000, #e_ai_st_noAI, _sp_mainchar

DefineEntity enemy, 60, 20, 8, 16, 0, 0, 0xF0, coll_type_enemy, 0, 0x0000, #e_ai_st_to_player, _sp_enemyNormal_03, animation_enemy_standing, enemy_animation_array, action_enemy_patrol
DefineEntity enemy2, 20, 10, 8, 16, 0, 0, 0xF0, coll_type_enemy, 0, 0x0000, #e_ai_st_stand_by, _sp_enemyDoble_03, animation_red_standing, red_animation_array, action_enemy_patrol
DefineEntity enemy3, 60, 20, 8, 16, 0, 0, 0xF0, coll_type_enemy, 0, 0x0000, #e_ai_st_stand_by, _sp_enemyDoble_03, animation_red_standing, red_animation_array, action_enemy_shoot
; DefineEntity enemy4, 60, 20, 16, 32, 0, 0, 0xF0, coll_type_enemy, 0, 0x0000, #e_ai_st_stand_by, _sp_enemyDoble_03, animation_boss_standing, boss_animation_array, action_enemy_shoot
DefineEntity player, 40, 80, 8, 16, 0, 0, 0xFF, coll_type_player, 1, 0x0000, #e_ai_st_noAI, _sp_enemyNormal_15, animation_player_standing, player_animation_array, action_enemy_patrol


DefineEntity elemento_00, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_00, 0x0000, 0x0000, action_enemy_patrol ;;CRATER
DefineEntity elemento_01, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_01, 0x0000, 0x0000, action_enemy_patrol ;; crater
DefineEntity elemento_02, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_02, 0x0000, 0x0000, action_enemy_patrol ;; crater
DefineEntity elemento_03, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_03, 0x0000, 0x0000, action_enemy_patrol ;; crater
DefineEntity elemento_04, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_04, 0x0000, 0x0000, action_enemy_patrol ;; valla doble
DefineEntity elemento_05, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_05, 0x0000, 0x0000, action_enemy_patrol ;; cubo 1
DefineEntity elemento_06, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_06, 0x0000, 0x0000, action_enemy_patrol ;; cubo 2
DefineEntity elemento_07, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_07, 0x0000, 0x0000, action_enemy_patrol ;; cubo 3
DefineEntity elemento_08, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_08, 0x0000, 0x0000, action_enemy_patrol ;; vaya doble 2
DefineEntity elemento_09, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_09, 0x0000, 0x0000, action_enemy_patrol ;; vaya derecha
DefineEntity elemento_10, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_10, 0x0000, 0x0000, action_enemy_patrol ;; vaya izquierda
DefineEntity elemento_11, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_11, 0x0000, 0x0000, action_enemy_patrol ;; fin agua
DefineEntity elemento_12, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_12, 0x0000, 0x0000, action_enemy_patrol ;; charco agua
DefineEntity elemento_13, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_13, 0x0000, 0x0000, action_enemy_patrol ;; rio lava
DefineEntity elemento_14, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_14, 0x0000, 0x0000, action_enemy_patrol ;; rio agua
DefineEntity elemento_15, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento_15, 0x0000, 0x0000, action_enemy_patrol ;; tuerca vida
DefineEntity elemento_16, 0, 0, 16, 32, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_cactus, 0x0000, 0x0000    , action_enemy_patrol  ;; cactus
DefineEntity elemento_final, 0, 0, 8, 8, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_lineaMeta,0x0000, 0x0000 , action_enemy_patrol     ;; final del nivel

DefineEntity elemento2_00, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento2_08, 0x0000, 0x0000, action_enemy_patrol ;; piedra
DefineEntity elemento2_01, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento2_09, 0x0000, 0x0000, action_enemy_patrol ;; flor verde
DefineEntity elemento2_02, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento2_10, 0x0000, 0x0000, action_enemy_patrol ;; flor roja
DefineEntity elemento2_03, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento2_11, 0x0000, 0x0000, action_enemy_patrol ;; flor blanca
DefineEntity elemento2_04, 0, 0, 8, 16, 0, 0, 0xF0, coll_type_nocoll, 0, 0x0000, #e_ai_st_noAI, _sp_elemento2_12, 0x0000, 0x0000, action_enemy_patrol ;; crater deformado


;;PRIVATE VARIABLES
gameoverscreen_bool:: .db 0
starscreen_bool:: .db 1
winscreen_bool:: .db 0
song_counter: .db 0
song_playing: .db 0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Sets the game over boolean on
;;
;; DESTROYS: AF, BC, DE, HL
;;
man_game_set_win::
    ld a, #1
    ld (winscreen_bool), a
    call rendersys_refreshscr

    ;;Load gameover song
    ld de, #_WinSong
    call cpct_akp_musicInit_asm
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Sets the game over boolean on
;;
;; DESTROYS: AF, BC, DE, HL
;;
man_game_set_gameover::
    ld a, #1
    ld (gameoverscreen_bool), a
    call rendersys_refreshscr

    ;;Load gameover song
    ld de, #_OverSong
    call cpct_akp_musicInit_asm
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Sets the game over boolean on
;;
;; DESTROYS: AF, BC, DE, HL
;;
man_game_set_startscr::
    ld a, #1
    ld (starscreen_bool), a
    call rendersys_refreshscr
    call cpct_akp_stop_asm
    ld a, #0
    ld (song_playing), a
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Inits the managers
;;
;;INPUT: -
;;DESTROYS: EVERYTHING! (Including your life ;)
;; HL
man_game_init::
    ;; Init managers
    call man_scroll_init

    ;; Init systems
    call rendersys_init
    call sys_input_init
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Starts new game
;;
;;INPUT: -
;;DESTROYS: EVERYTHING! (Including your life ;)
;; HL
man_game_newgame::
    ;; Set song
    ld de, #_start
    call cpct_akp_musicInit_asm


    ;; Init managers
    call entityman_init
    call man_player_init
    call man_player_init
    call man_collision_init
    call man_scroll_newgame
    

    ;; Init systems
    call entityman_getEntityArray
    call sys_ai_control_init
    call rendersys_init
    call physics_init
    call sys_input_init

    ;; Init 3 Test Entities
    ld hl, #player
    call entityman_create
;     ld hl, #enemy
;     ;call entityman_create
;     ld hl, #enemy2
;     ld hl, #enemy3
;     call entityman_create
   ; ld hl, #block
   ; call entityman_create

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;;PARTE ELEMENTOS MAPA
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;ld hl, #elemento_00
    ;call entityman_create

    ld a, #startsong_cicles
    ld (song_counter), a

    ld a, #1
    ld (song_playing), a
    ret

; man_game_gameover::
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Updates 1 Game Cycle doing everything
;; except the rendering
;;
;;INPUT: -
;;DESTROYS: EVERYTHING!
;;
man_game_update::
    ;; Always read keys!
    call entityman_getEntityArray
    call sys_input_update


    ld a, (starscreen_bool)
    cp #1                           ;; if true
    jr nz, _notstart_up
_isstart_up:                            ;; when its start screen
    ld a, (key_c_pressed)                ;; Memory controlling if key c is pressed
    cp #1
    jr nz, _not_pressed_start           ;; If not pressed jump
        ;;Disable start screen
        xor a                           ;; load 0 value on A
        ld (starscreen_bool), a         ;; IF pressed, put start screen bool = 0 (false).
        call man_game_init
        call man_game_newgame
        call rendersys_refreshscr
    _not_pressed_start:
    jp _endupdate_up

_notstart_up:                           ;; else

    ld a, (gameoverscreen_bool)
    cp #1                               ;;if true
    jr nz, _notover_up
_isover_up:
    ld a, (key_c_pressed)               ;; Boolean on memory controlling if key c is pressed
    cp #1
    jr nz, _not_pressed_over            ;; If not pressed jump
        ;;Disable game over screen
        xor a                           ;; load 0 value on A
        ld (gameoverscreen_bool), a    ;; IF pressed, put gameover screen bool = 0 (false).
        ; call rendersys_refreshscr
        ;;Put start screen on
        call man_game_set_startscr
    _not_pressed_over:
    jp _endupdate_up

_notover_up:

    ld a, (winscreen_bool)
    cp #1                               ;;if true
    jr nz, _notwin_up
_iswin_up:
    ld a, (key_c_pressed)               ;; Boolean on memory controlling if key c is pressed
    cp #1
    jr nz, _not_pressed_win            ;; If not pressed jump
        ;;Disable game over screen
        xor a                           ;; load 0 value on A
        ld (winscreen_bool), a    ;; IF pressed, put gameover screen bool = 0 (false).
        ; call rendersys_refreshscr
        ;;Put start screen on
        call man_game_set_startscr
_not_pressed_win:
    jp _endupdate_up

_notwin_up:

    ;;Normal game loop update
    call entityman_getEntityArray
    call man_animation_update

    call entityman_getEntityArray
    call sys_ai_control_update          ;; Update ai_control

    call man_scroll_update  

    call entityman_getEntityArray
    call physics_update                 ;; Update physics

    call entityman_getCollisionArray
    call man_collision_update           ;; Check collisions

    call man_player_update
    
    call entityman_update

    ;;Set correct song
    ld a, (song_counter)
    or a
    jp z, _endupdate_up
    dec a
    ld (song_counter), a
    jp nz, _endupdate_up
    ld de, #_invasion
    call cpct_akp_musicInit_asm

_endupdate_up:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Manages the render of the graphics of the game
;;
;;INPUT: -
;;DESTROYS: EVERYTHING
;;
man_game_renderer::
    ld a, (starscreen_bool)
    cp #1                           ;; if true
    jr nz, _notstart_ren
_isstart_ren:                           ;; when its start screen
    call rendersys_startscr          ;;Render the start screen
    jp _endupdate_ren

_notstart_ren:                          ;; else

    ld a, (gameoverscreen_bool)
    cp #1                           ;;if true
    jr nz, _notover_ren
_isover_ren:
    call rendersys_gameoverscr          ;;Render the gameover screen
    jp _endupdate_ren

_notover_ren:

    ld a, (winscreen_bool)
    cp #1                           ;;if true
    jr nz, _notwin_ren
_iswin_ren:
    call rendersys_dibujarPantallaFin    ;;Render the win screen
    jp _endupdate_ren

_notwin_ren:
    ;;Normal renderer cicle
    call man_game_wait
    call entityman_getEntityArray
    call rendersys_update
_endupdate_ren:
    ret


render_interrupt:: .db #00
intf_interrupt:: .db #00
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Pauses the processor waiting to the rasterizer
;; to end
;;
;;INPUT: -
;;DESTROYS: -
;;
man_game_wait::
    ;;Wait to the render interruption
_mgw_loop:
    ld a, (render_interrupt)
    cp #01
    jp nz, _mgw_loop
    ret