;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo		tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez	abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina		imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;
;;	PATROL MANAGER
;;
.include "man/patrol_manager.h.s"
.include "man/entity_manager.h.s"

_patrol_counter: .db 00

;; Square patrol
patrol_01:
	;;	x	y
	.db	6,	6
	.db	30,	6
	.db	30,	60
	.db	6,	60
	.db	patrol_invalid_move_x 
	.dw	patrol_01	;;cycle

;;Horizontal patrol
patrol_02:
	.db	40,	6
	.db	70,	6
	.db	patrol_invalid_move_x
	.dw	patrol_02	;;cycle

;;Horizontal patrol and charge
patrol_03:
	.db	10, 	60
	.db	40, 	60
	.db	patrol_invalid_move_x
	.dw 	patrol_03

;;; Set IA to enemy
;;; IX = Entity
;;; 
man_patrol_get::
	ld	a, (_patrol_counter)
	cp 	#0
	call 	z, p1
	cp	#1
	call 	z, p2
	cp	#2
	call 	z, p3

	ret
p1:
	ld	hl, #_patrol_counter
	inc	(hl)
	ld	hl, #patrol_01
	ret
p2:
	ld	hl, #_patrol_counter
	inc 	(hl)
	ld	hl, #patrol_02
	ret
p3:
	ld	hl, #0x0000
	ld 	(_patrol_counter), hl
	ld	hl, #patrol_03
	ret