;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo       tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina      imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;INPUT
;;ix: pointer to object 1
;;iy: pointer to object 2
;;DESCRIPTION
;;Checks if object 1 collides with object 2
;;DESTROYS: A, HL, BC
;;RETURNS:
;; FLAG_Z: 0 if not collides, 1 if collides
collision_check::
    ;;xi2 <= xf1?
    ld h, 0(iy)                 ;; xi2
    ld a, 0(ix)                 ;; xf1
    ld b, 2(ix)                 ;; whidth
    add a, b
    cp h
    jp c, _not_collides          ;; IF a < h not collides -> !(xi2 <= xf1)

    ;;xf2 >= xi1
    ld h, 0(ix)                 ;; xi1
    ld a, 0(iy)                 ;; xf2
    ld b, 2(iy)                 ;; whidth
    add a, b
    cp h
    ; jp z, still_collides_x      ;; Check equal before
    jp c, _not_collides          ;; IF a < h not collides -> !(xf2 >= xi1)
; still_collides_x:

    ;;yi2 <= yf2
    ld h, 1(iy)                 ;; yi2
    ld a, 1(ix)                 ;; yf1
    ld b, 3(ix)                 ;; height
    add a, b
    cp h
    jp c, _not_collides          ;; IF a < h not collides -> !(yi2 <= yf1)

    ;;yf2 >= yi1
    ld h, 1(ix)                 ;; yi1
    ld a, 1(iy)                 ;; yf2
    ld b, 3(iy)                 ;; height
    add a, b
    cp h
    jp c, _not_collides          ;; IF a < h not collides -> !(yf2 >= yi1)

    xor a                       ;; Put z flag to 1
    ret

_not_collides:
    ld a, #1                        ;; Put z flag to 0popo
    ret