;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of Invasion a Marte: An Amstrad CPC Game 
;; Copyright (C) 2019 
;; Authors:
;;  * Antonio Macia Lillo       tonetml23@gmail.com
;;  * Gina Esthela Abad Jimenez abadjimenezgina@gmail.com
;;  * Ivan Martinez Molina      imm79@alu.ua.es
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "man/entity_manager.h.s"
.include "man/player_manager.h.s"
.include "scroll_system.h.s"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPTION
;; Scrolls the array of entitys passed on IX down
;; by substracting the player speed to all entities
;;
;;INPUT: 
;;  IX: Array of entities to scroll
;;  A: Number of entities of the array
;;  BC: Entity size
;;DESTROYS: AF, BC, DE
;;
scrollsys_move::
    ld (_ent_counter), a                    ;; Save number of entities with automodifiable code
    ld (_ent_size), bc                      ;; Save entity size using automodifiable code
    
    ld b, #player_negative_speed_y          ;; Load the y speed of the player on b TODO CHAGE THIS TO THE SPEED SAVED ON PLAYER MANAGER
    ld (_player_speed), bc                  ;; Save player speed using automodifiable code
    
msm_loop:                                   ;; Loop over all entities of the array
_player_speed = .+1                          
    ld bc, #0000                            ;; B: Player speed
    ld a, e_y(ix)                           ;; Load the position of the  entity on a
    sub b
    ld e_y(ix), a                           ;; Save the new y position

_ent_size = .+1              
    ld bc, #0000                ;; BC: Entity size
    add ix, bc                  ;; IX now points on the next entity
    
_ent_counter = .+1              ;;
    ld a, #0                    ;; A: Number of elements left
    dec a                       ;; numberofelements--
    ld (_ent_counter), a
    jp nz, msm_loop

    ret